<template>
  <a
    class="reversed"
    :href="`mailto:${obfuscatedEmail}`"
    @mouseover="revealEmail"
  >
    <slot>{{ reversedEmail }}</slot>
  </a>
</template>

<script lang="ts">
import Vue from 'vue';

const OBFUSCATION_TEXT = 'this.is.to.avoid.spam';

export default Vue.extend({
  props: {
    email: {
      type: String,
      required: true,
    },
  },

  data() {
    return {
      emailRevealed: false,
    };
  },

  computed: {
    reversedEmail(): string {
      return this.email.split('').reverse().join('');
    },
    obfuscatedEmail(): string {
      return `${OBFUSCATION_TEXT}.${this.reversedEmail}.${OBFUSCATION_TEXT}`;
    },
  },

  methods: {
    revealEmail(event: Event): void {
      if (this.emailRevealed) return;

      (event.currentTarget as HTMLAnchorElement).setAttribute('href', `mailto:${this.email}`);
      this.emailRevealed = true;
    },
  },
});
</script>

<style>
.reversed {
  unicode-bidi: bidi-override;
  direction: rtl;
}
</style>
